﻿using UnityEngine;
using System.Collections;

public class TiledLevel : MonoBehaviour{
	public short[,] tiles = 
	{{84,	72,	72,	72,	72,	72,	72,	72,	72,	72,	72,	72,	72,	72,	72,	72,	72,	85},
	{60,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	58},
	{60,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	58},
	{60,	20,	20,	20,	3,	4,	5,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	58},
	{60,	20,	20,	20,	16,	17,	18,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	58},
	{60,	20,	20,	20,	29,	30,	31,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	58},
	{60,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	58},
	{97,	47,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	58},
	{59,	60,	20,	20,	20,	20,	20,	20,	20,	61,	62,	63,	64,	20,	20,	20,	20,	58},
	{14,	60,	20,	20,	20,	20,	20,	20,	20,	74,	75,	76,	77,	20,	20,	20,	20,	34},
	{59,	97,	46,	49,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	13},
	{59,	6,	7,	73,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	13},
	{59,	19,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	38,	59},
	{59,	32,	49,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	20,	50,	51,	14},
	{59,	14,	1,	92,	94,	95,	96,	93,	91,	92,	94,	96,	95,	92,	91,	1,	59,	14}};//*/
	public Tileset tileset;
	public int w = 16 , h = 15;
	public Vector2 tileSize;
	public GameObject tilePrefab;
	/*
	public TiledLevel(){
		this.w = w;
		this.h = h;
		this.tiles = new short[w,h];
		this.tileset = tileset;
	}
	*/
	void Start(){
		tileset = new Tileset();
		tileset.Load ("grass and sky");

		SpriteRenderer rend = tilePrefab.GetComponent<SpriteRenderer>();

		tileSize = rend.sprite.bounds.size;

		for(int i = 0; i < w; i++){
			for(int j = 0; j < h; j++){
				Vector3 pos = new Vector3(i * tileSize.x, (h - j - 1) * tileSize.y, 0);
				GameObject tileObj = GameObject.Instantiate (tilePrefab, pos, Quaternion.identity) as GameObject;
				tileObj.transform.parent = this.transform;
				rend = tileObj.GetComponent<SpriteRenderer>();
				int idx = tiles[j,i];
				rend.sprite = tileset.tiles[idx % tileset.cols, idx / tileset.cols].sprite;
			}
		}
	}

	public Tile GetTile(Vector3 pos){
		int idx = tiles[(int)(pos.x / tileSize.x), (int)(pos.y / tileSize.y)];
		Debug.Log ("compared to tile " + (int)(pos.x / tileSize.x) + "," + (int)(pos.y / tileSize.y));
		return tileset.tiles[idx % tileset.cols, idx / tileset.cols];
	}
}
